package org.nuiton.topiatest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class ExtraDAOEntityDAOAbstract<E extends ExtraDAOEntity> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)ExtraDAOEntity.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.ExtraDAOEntity;
    }

    public abstract void extra() throws TopiaException;

    public E findByAttr1(String v) throws TopiaException {
        E result = findByProperty(ExtraDAOEntity.PROPERTY_ATTR1, v);
        return result;
    }

    public List<E> findAllByAttr1(String v) throws TopiaException {
        List<E> result = findAllByProperty(ExtraDAOEntity.PROPERTY_ATTR1, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //ExtraDAOEntityDAOAbstract<E extends ExtraDAOEntity>
