package org.nuiton.topiatest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class GeneralizedNaturalizedEntityDAOAbstract<E extends GeneralizedNaturalizedEntity> extends NaturalizedEntityDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)GeneralizedNaturalizedEntity.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.GeneralizedNaturalizedEntity;
    }

    public E findByNaturalId(Integer naturalIdNotNull, String naturalIdNull) throws TopiaException {
        return findByProperties(GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NOT_NULL, naturalIdNotNull, GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NULL, naturalIdNull);
    }

    public boolean existByNaturalId(Integer naturalIdNotNull, String naturalIdNull) throws TopiaException {
        return existByProperties(GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NOT_NULL, naturalIdNotNull, GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NULL, naturalIdNull);
    }

    /**
     * @deprecated since 2.6.10, prefer use {@link #createByNaturalId}
     * @param naturalIdNotNull 
     * @param naturalIdNull 
     * @return 
     * @throws TopiaException
     */
    @Deprecated
    public E create(Integer naturalIdNotNull, String naturalIdNull) throws TopiaException {
        return create(GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NOT_NULL, naturalIdNotNull, GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NULL, naturalIdNull);
    }

    public E createByNaturalId(Integer naturalIdNotNull, String naturalIdNull) throws TopiaException {
        return create(GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NOT_NULL, naturalIdNotNull, GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NULL, naturalIdNull);
    }

    public E createByNotNull(Integer naturalIdNotNull) throws TopiaException {
        return create(GeneralizedNaturalizedEntity.PROPERTY_NATURAL_ID_NOT_NULL, naturalIdNotNull);
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //GeneralizedNaturalizedEntityDAOAbstract<E extends GeneralizedNaturalizedEntity>
