package org.nuiton.topiatest.beangen;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import org.nuiton.i18n.I18n;

public abstract class Siege implements Serializable {

    private static final long serialVersionUID = 3918756440566019939L;

    public static final String PROPERTY_NO_SERIE = "noSerie";

    public static final String PROPERTY_VOITURE = "voiture";

    protected int noSerie;

    protected Voiture voiture;

    protected final PropertyChangeSupport pcs = new PropertyChangeSupport(this);

    static {
    
        I18n.n_("topia.test.common.siege");
        I18n.n_("topia.test.common.noSerie");
        I18n.n_("topia.test.common.voiture");
    }

    public int getNoSerie() {
        return noSerie;
    }

    public void setNoSerie(int noSerie) {
        int oldValue = getNoSerie();
        this.noSerie = noSerie;
        firePropertyChange(PROPERTY_NO_SERIE, oldValue, noSerie);
    }

    public Voiture getVoiture() {
        return voiture;
    }

    public void setVoiture(Voiture voiture) {
        Voiture oldValue = getVoiture();
        this.voiture = voiture;
        firePropertyChange(PROPERTY_VOITURE, oldValue, voiture);
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        pcs.addPropertyChangeListener(listener);
    }

    public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        pcs.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        pcs.removePropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        pcs.removePropertyChangeListener(propertyName, listener);
    }

    protected void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
        pcs.firePropertyChange(propertyName, oldValue, newValue);
    }

    protected void firePropertyChange(String propertyName, Object newValue) {
        firePropertyChange(propertyName, null, newValue);
    }

} //Siege
